#ifndef MY_CALLBACK_TYPE
#define MY_CALLBACK_TYPE

#include <iostream>
#include "windows.h"

#include "DFITCL2Api.h"

extern HANDLE g_h_event;
extern bool g_b_login;
extern bool g_b_logout;
using namespace DFITC_L2;
class MyCallback : public DFITC_L2::DFITCL2Spi{
public:
    MyCallback()  { }
    ~MyCallback() { }
    void OnRspUserLogin(struct ErrorRtnFiled * pErrorFiled)
    {
        std::cout << "MyCallback::OnRspUserLogin" << std::endl;
        if (0 == pErrorFiled->ErrorID)
        {
            g_b_login = true;
        }
        else
        {
            std::cout << pErrorFiled->ErrorMsg << std::endl;
        }
        SetEvent(g_h_event);
    }
    void OnRspUserLogout(struct ErrorRtnFiled * pErrorFiled) 
    {
        std::cout << "MyCallback::OnRspUserLogout" << std::endl;
        if (0 == pErrorFiled->ErrorID)
        {
            g_b_logout = true;
        }
        else
        {
            std::cout << pErrorFiled->ErrorMsg << std::endl;
        }
        SetEvent(g_h_event);
    }
    void OnRspModifyPassword(struct ErrorRtnFiled * pErrorFiled) { std::cout << "MyCallback::OnRspModifyPassword" << std::endl; }
    void OnBestAndDeep(MDBestAndDeep * const pQuote)
    {
        std::cout << pQuote->Contract << ": " << pQuote->LastPrice << std::endl;
        std::cout << "MyCallback::OnBestAndDeep" << std::endl;
    }
    void OnArbi(MDBestAndDeep * const pQuote){}
    void OnTenEntrust(MDTenEntrust * const pQuote)         { std::cout << "MyCallback::OnTenEntrust" << std::endl; }
    void OnRealtime(MDRealTimePrice * const pQuote)        { std::cout << "MyCallback::OnRealtime" << std::endl; }
    void OnOrderStatistic(MDOrderStatistic * const pQuote) { std::cout << "MyCallback::OnOrderStatistic" << std::endl; }
    void OnMarchPrice(MDMarchPriceQty * const pQuote)      { std::cout << "MyCallback::OnMarchPrice" << std::endl; }
protected:
    DFITC_L2::DFITCL2Api *md_pApi;
};

#endif
