#include <iostream>
#include <string>

#include "DFITCL2Api.h"
#include "MyCallback.h"


#pragma comment(lib, "level2Api.lib")
HANDLE g_h_event = INVALID_HANDLE_VALUE;
bool g_b_login   = false;
bool g_b_logout  = false;

int main()
{
    DFITC_L2::DFITCL2Api * p = NEW_CONNECTOR();
    MyCallback a;
    
    g_h_event = CreateEvent(NULL, TRUE, FALSE, NULL); // manual reset, no signaled

    if(0 == p->Connect("tcp://203.86.95.178:10936", &a, 1))
    {
        std::cout << "Connect successfully" << std::endl;
    }
    else
    {
        std::cout << "Connect failed" << std::endl;
        DELETE_CONNECTOR(p);
        return 1;
    }
    Sleep(100);

    struct DFITCUserLoginField user_login;
    std::string name("test");
    std::string password("test");
    strcpy(user_login.accountID, name.c_str());
    strcpy(user_login.passwd, password.c_str());
    if (0 == p->ReqUserLogin(&user_login))
    {
        std::cout << "send login command successfully" << std::endl;
    }
    else
    {
        std::cout << "send login command failed" << std::endl;
        DELETE_CONNECTOR(p);
        return 1;
    }
    if (WAIT_OBJECT_0 == WaitForSingleObject(g_h_event, INFINITE))
    {
        if (g_b_login)
        {
            std::cout << "login successfully" << std::endl;
        }
        else
        {
            std::cout << "login failed" << std::endl;
            DELETE_CONNECTOR(p);
            return 1;
        }
    }

    ResetEvent(g_h_event);
    char * contracts[3]={"", "", ""};
    contracts[0] = "m1301";
    contracts[1] = "p1301";
    contracts[2] = "m1305";
    int count = 3;

    if (0 == p->SubscribeMarketData(contracts, count))
    {
        std::cout << "send subscribe command successfully" << std::endl;
    }
    else
    {
        std::cout << "send subscribe command failed" << std::endl;
    }
    
    Sleep(30 * 1000);
    struct DFITCUserLogoutField user_logout;
    strcpy(user_logout.AccountID, name.c_str());
    if (0 == p->ReqUserLogout(&user_logout))
    {
        std::cout << "send logout command successfully" << std::endl;
    }
    else
    {
        std::cout << "send logout command failed" << std::endl;
    }
    if (WAIT_OBJECT_0 == WaitForSingleObject(g_h_event, INFINITE))
    {
        if (g_b_logout)
        {
            std::cout << "logout successfully" << std::endl;
        }
        else
        {
            std::cout << "logout failed" << std::endl;
        }
    }
    DELETE_CONNECTOR(p);
    return 0;
}
